#!/usr/bin/env python
# coding: utf-8

# In[47]:


import moviepy.editor

from pydub import AudioSegment
from pydub.utils import make_chunks
import os 
import speech_recognition as sr  
from pydub import AudioSegment
import wave
import requests
from time import sleep
import docx
import contractions
import unicodedata
import re
import string
import re
import nltk
from nltk.corpus import stopwords
import matplotlib.pyplot as plt
from wordcloud import WordCloud
import matplotlib.pyplot as plt
from wordcloud import WordCloud
from os import listdir
from os.path import isfile, join
nltk.download('stopwords')
from nltk.tokenize import word_tokenize
from fuzzywuzzy import fuzz
from textblob import TextBlob
import pandas as pd
import numpy as np
import requests
from time import sleep
import fuzzywuzzy
from fuzzywuzzy import process
import openai
import time
import xlwings as xw
import glob
from datetime import datetime
import os
import pandas as pd
import glob
from openpyxl import load_workbook
from collections import Counter
import spacy
from spacy import displacy
NER = spacy.load("en_core_web_sm")




def Video_to_Audio(path):
    r = sr.Recognizer()
    vv = moviepy.editor.VideoFileClip(path)
    a = vv.audio
    return  a.write_audiofile('Audio.wav')
def read_audio_file(filename, chunk_size=5242880):
    with open(filename, 'rb') as _file:
        while True:
            data = _file.read(chunk_size)
            if not data:
                break
            yield data


def Create_Transcript():
    path = 'Audio.wav'
    headers = {'authorization': "eed89a75c4f74d08948bd91f912683dc"}
#     headers = {'authorization': "664796c755154ae49b235c79bd3b8890"} 
    response = requests.post('https://api.assemblyai.com/v2/upload',
                            headers=headers,
                            data=read_audio_file(path))

    audio_url = response.json()['upload_url']
    print("Audio_Processing_initiated")
    endpoint = "https://api.assemblyai.com/v2/transcript"
    json = { "audio_url": str(audio_url) }
    response = requests.post(endpoint, json=json, headers=headers)
    job_id = response.json()['id']
    polling_endpoint = endpoint +'/'+job_id
    polling  = requests.get(polling_endpoint, headers=headers)
    while polling.json()['status'] == "processing":
        sleep(5)
        polling  = requests.get(polling_endpoint, headers=headers)
        print(polling.json()['status'])
    print("Transcript is ready ")
    Transcript  = polling.json()['text']
    f = open('transcript.txt', "a")
    f.write(Transcript)
    f.close()
    
def text_cleansing(human_intelligent):
    for i in human_intelligent:
        text = getText(mypath + '/'+ str(i))
        text = contractions.fix(text)
        text = remove_accented_chars(text)
        output_path = text_Cleaning_output_path +  str(i.replace(".docx", '')) +'.txt'
        f = open(output_path, "a")
        f.write(text)
        f.close()
        
def text_blob(text):
    blob = TextBlob(text)
    p = []
    for sentence in blob.sentences:
        p.append(sentence.sentiment.polarity)
    w = blob.sentences
    out = pd.DataFrame({

        'sentence': w,
        'polarity':p
    })
    sent = []
    for i in range(len(out['sentence'])):
        sent.append(str(out['sentence'][i]))
    return sent


def split_into_sentences(text):
    alphabets= "([A-Za-z])"
    prefixes = "(Mr|St|Mrs|Ms|Dr)[.]"
    suffixes = "(Inc|Ltd|Jr|Sr|Co)"
    starters = "(Mr|Mrs|Ms|Dr|He/s|She/s|It/s|They/s|Their/s|Our/s|We/s|But/s|However/s|That/s|This/s|Wherever)"
    acronyms = "([A-Z][.][A-Z][.](?:[A-Z][.])?)"
    websites = "[.](com|net|org|io|gov)"
    digits = "([0-9])"
    text = " " + text + "  "
    text = text.replace("/n"," ")
    text = re.sub(prefixes,"//1<prd>",text)
    text = re.sub(websites,"<prd>//1",text)
    text = re.sub(digits + "[.]" + digits,"//1<prd>//2",text)
    if "..." in text: text = text.replace("...","<prd><prd><prd>")
    if "Ph.D" in text: text = text.replace("Ph.D.","Ph<prd>D<prd>")
    text = re.sub("/s" + alphabets + "[.] "," //1<prd> ",text)
    text = re.sub(acronyms+" "+starters,"//1<stop> //2",text)
    text = re.sub(alphabets + "[.]" + alphabets + "[.]" + alphabets + "[.]","//1<prd>//2<prd>//3<prd>",text)
    text = re.sub(alphabets + "[.]" + alphabets + "[.]","//1<prd>//2<prd>",text)
    text = re.sub(" "+suffixes+"[.] "+starters," //1<stop> //2",text)
    text = re.sub(" "+suffixes+"[.]"," //1<prd>",text)
    text = re.sub(" " + alphabets + "[.]"," //1<prd>",text)
    if "”" in text: text = text.replace(".”","”.")
    if "\"" in text: text = text.replace(".\"","\".")
    if "!" in text: text = text.replace("!/"","/"!")
#     if "?" in text: text = text.replace("?/"","/"?")
    text = text.replace(".",".<stop>")
    text = text.replace("?","?<stop>")
    text = text.replace("!","!<stop>")
    text = text.replace("<prd>",".")
    sentences = text.split("<stop>")
    sentences = sentences[:-1]
    sentences = [s.strip() for s in sentences]
    return sentences  

command = ["Given a transcript, get summary:\n\nTranscript: ", "\n\nSummary:"]
def inference(x , y , z, input_text, command, mode="summary"  ):
    command = ["Given a transcript, get summary:\n\nTranscript: ", "\n\nSummary:"]
    prompt =  input_text + command[1]
    try:
        response = openai.Completion.create(
              engine= "davinci-instruct-beta-v3", #"davinci-instruct-beta-v3", #self.ENGINE@" #"davinci-instruct-beta-v3", #"ada-instruct-beta",
              prompt=prompt,
              temperature= y,
              max_tokens= x, 
              top_p= z,
              frequency_penalty=0,
              presence_penalty=0,
              # stop=["\n"],
              # n=3,
              # best_of=1, 
        )
    except:
            periods = [i for i, x in enumerate(input_text) if x == "."]
            period = periods[len(periods)//2]
            input_text = input_text[:period+1]

            prompt = command[0] + input_text + command[1]

            response = openai.Completion.create(
              engine= "davinci-instruct-beta-v3", #self.ENGINE", #"davinci-instruct-beta-v3", #"ada-instruct-beta",
              prompt=prompt,
              temperature= y,
              max_tokens= x, 
              top_p= z,
              frequency_penalty=0,
              presence_penalty=0,
              #stop=["\n"],
              #n=3,
              #best_of=1,
            )

    if mode == "summary":
        summary = response["choices"][0]["text"]
        return summary.replace("\n","").strip()
    elif mode == "title":
        title = response["choices"][0]["text"]
        return title.replace("\n","").strip()
    elif mode == "topics":
        topics = response["choices"][0]["text"]
        topics = topics[:-1] if topics.endswith(",") else topics
        return topics.replace("\n","").strip()
    elif mode == "sentiment":
        sentiment = response["choices"][0]["text"]
        return sentiment.replace("\n","").strip()


def splting_Questions_Answers(sent):
    #spliting based on ?
    chu = []
    chu2 = []
    first = ""
    count = 0
    for i in sent:
        if ("?" not in i) :
            chu.append(i)
        else :
            if count == 0:
                first = sent.index(i)
                count = 1
            chu2.append("".join(chu))
            chu2.append(i)
            chu=[]
    first_combine = []
    for k in range(0, first):
        first_combine.append(sent[k])

    chu2.append(" ".join(first_combine[0:len(first_combine)]))
    chu22 = []
    for i in chu2:
        if i == "":
            continue
        chu22.append(i)

    ques = []
    anss = []
    x = []
    y = []
    for i in range(len(chu22)):
        if chu22[i] == "":
            continue
        if chu22[i] in y:
            continue
        x = []
        if "?" in chu22[i]:
            x.append(chu22[i])
            mm=0
            y=[]
            for m in range(1, 10):
                try:
                    if "?" in chu22[i+m]:
                        x.append(chu22[i+m])
                        y.append(chu22[i+m])
                        mm = m
                    else :
                        break
                except Exception:
                    break
            ques.append("".join(x))
            i = i + mm 
        elif "set of questions relates to new study sites" in chu22[i]:
            ll = []
            sent_small = text_blob(chu22[i])
            for b in range(len(sent_small)):
                ll.append(sent_small[b])
            ques.append(" ".join(ll[0:3]))
            anss.append(" ".join(ll[4:len(ll)]))
            continue    
        
            
            
        if "?" not in chu22[i]:
            if i == 0:
                continue
            anss.append(chu22[i])
    return ques , anss
        
def topics_gpt3(input_text):
        response = openai.Completion.create(
          engine="davinci-instruct-beta-v3",
          prompt=f"Given a transcript, get tags:\n\nTranscript: {input_text}\n\nTags:",
          temperature=0,  
          max_tokens=10,
#           top_p=1,
          frequency_penalty=0,
          presence_penalty=0,
          #stop=["\n"],
          #n=3,
          #best_of=1,
        )
        topics = response["choices"][0]["text"]
        topics = topics[:-1] if topics.endswith(",") else topics
        print("tags Completed")
        return topics.replace("\n","").strip()

    
def title_gpt3(input_text):
        response = openai.Completion.create(
          engine="davinci-instruct-beta-v3",
          prompt=f"Given a transcript, get headline:\n\nTranscript: {input_text}\n\nHeadline:",
          temperature=0,
          max_tokens=15,
#           top_p=1,
          frequency_penalty=0,
          presence_penalty=0,
          #stop=["\n"],
          #n=3,
          #best_of=1,
        )
        title = response["choices"][0]["text"]
        print("title Completed")
        return title.replace("\n","").strip().strip()
    
    
def title(x):
    response = openai.Completion.create(
        model="text-davinci-003",
      prompt= " create heading for the summary:"  + x,
      temperature=0,
      max_tokens=20,
      top_p=1.0,
      frequency_penalty=0.0,
      presence_penalty=0.0
    )
    return response['choices'][0]['text']

def formatting_out_put(filename, outpath):
    wb = load_workbook(filename, read_only=True, keep_links=False)
    sheet_name_list = wb.sheetnames
    
    wb = xw.Book()
    for sheet_n in range(len(sheet_name_list)):
        df = pd.read_excel(filename, sheet_name = sheet_name_list[sheet_n] )
        df = df.iloc[:,1::]
        shennat_name = str(sheet_name_list[sheet_n])
        if sheet_n < len(sheet_name_list):
            wb.sheets.add()
        
    
        sht = wb.sheets["Sheet"+str(sheet_n+1)]
        sht.name = sheet_name_list[sheet_n]
        sht.range("A1").options(index=False).value = df
        all_data_range = sht.range("A1").expand('table')
        all_data_range.row_height = 45
        all_data_range.column_width = 32
        all_data_range.color = (255,255,255)
        all_data_range.api.Font.Name = 'Roboto'
        all_data_range.api.Font.Size = 9
        all_data_range.api.HorizontalAlignment = xw.constants.HAlign.xlHAlignLeft
        all_data_range.api.VerticalAlignment = xw.constants.HAlign.xlHAlignCenter
        all_data_range.api.WrapText = True
        header_range = sht.range("A1").expand('right')
        # header_range.color = (92,0,163)
        header_range.color =  '#004567'   # (1,19,138)
        header_range.api.Font.Color =  0xececec #(45, 243, 155)  
        header_range.api.Font.Bold = True
        header_range.api.Font.Size = 12
        header_range.row_height = 25
        header_range.api.Font.Size = 14
        header_range.api.HorizontalAlignment = xw.constants.HAlign.xlHAlignCenter
        id_column_range = sht.range("A2").expand('down')
        id_column_range.color= '#004567'   #(1,19,138)
        # sht.range('A1:A10').api.Font.Color = 0xFFFFF
        id_column_range.api.Font.Color = 0xececec
        id_column_range.api.Font.Bold = True
        id_column_range.api.Font.Size = 10
        id_column_range.api.HorizontalAlignment = xw.constants.HAlign.xlHAlignCenter
        id_column_range.column_width = 16.67
        div_column_range = sht.range("C1").expand('down')
        div_column_range.column_width = 50
        div_column_range = sht.range("B1").expand('down')
        div_column_range.column_width = 90
        div_column_range = sht.range("B2").expand('down')
        div_column_range.row_height = 80
        div_column_range.color =  (255,255,255)
        data_ex_headers_range = sht.range("A1").expand('table')
        for border_id in range(7,13):
            data_ex_headers_range.api.Borders(border_id).Weight = 2
            data_ex_headers_range.api.Borders(border_id).Color = 0x1d1d1d # 0xA532
        sht.range("A1").expand('down').insert()
        sht.range("A1").characters[123].api.Text= "Filename"
        number_of_rows = sht.range('B' + str(wb.sheets[0].cells.last_cell.row)).end('up').row
        topic_column_range = sht.range("A2:A"+str(number_of_rows))
        topic_column_range.value= sheet_name_list[sheet_n]
        topic_column_range = sht.range("A1:A"+str(number_of_rows))
        topic_column_range.color=  '#004567'
        topic_column_range.api.Font.Color = 0xececec
        topic_column_range.api.Font.Bold = True
        topic_column_range.api.Font.Size = 10
        topic_column_range.api.HorizontalAlignment = xw.constants.HAlign.xlHAlignCenter
        topic_column_range.api.VerticalAlignment = xw.constants.HAlign.xlHAlignCenter
        topic_column_range.column_width = 16
        filen = sht.range("A1")
        filen.api.Font.Size = 14
        filen.api.HorizontalAlignment = xw.constants.HAlign.xlHAlignCenter
    
    wb.sheets['Sheet'+ str(len(sheet_name_list)+1)].delete()
    wb.save(outpath + filename.split("/")[-1]+".xlsx")
    app = xw.apps.active
    app.quit()    

def make_output():
    text = getText('transcript.txt')
#     print(transcript)
    sent  = split_into_sentences(text)
    df = pd.DataFrame(list(zip( sent )),
                      columns=['Sentence'])
    mm = []
    df['Sentence_tag'] = "COMMON"
    for k in range(len(df['Sentence'])):
        text1= NER(df['Sentence'][k])
        mm = []
        for word in text1.ents:
    #         print(k)
    #         print(word.label_)
    #         print("######################")
            mm.append(word.label_)
        df['Sentence_tag'][k] = " ,".join(mm)

    # df['length'] =  df['Sentence'].apply(lambda x: len(x.split(" ")))
    # dff = df[df['length'] > 25]
    dff = df
    dff = df.replace('' , np.nan , regex = True)
    dff['Sentence_tag']=dff.Sentence_tag.fillna("COMMON")
    # # dff['Topics_tag'] = dff['Topics_tag'].fillna(" ")
    # dff = dff.reset_index()
    # dff =  dff.drop(['index'] , axis = 1)

    dff['Sentence_tag2'] = " "
    for m in range(len(dff['Sentence_tag'])):
        dff['Sentence_tag2'][m] = max(dff['Sentence_tag'][m].split(","),key=dff['Sentence_tag'][m].split(",").count)

    count = 0
    jj = 1
    for mm in range(len(dff['Sentence_tag2'])):
        if dff['Sentence_tag2'][mm] == 'COMMON':
            if ((count == 40) | (count == 80 ) | (count == 120 ) | (count == 160 ) | (count == 200) | (count == 240 )):
                jj = jj+1

            dff['Sentence_tag2'][mm] = 'COMMON_' + str(jj)
            count = count + 1


    dfx = dff.groupby(['Sentence_tag2' ]).agg({'Sentence':'. '.join }).reset_index()
    for k in range(len(dfx['Sentence'])):
        ll = dfx['Sentence'][k]
        sent_x  = split_into_sentences(ll)
        for kk in sent_x:
            if "?" in kk:
                sent_x.remove(kk)
        dfx['Sentence'][k] = " ".join(sent_x)
    dfx['length'] =  dfx['Sentence'].apply(lambda x: len(x.split(" ")))     

    dfx = dfx[dfx['length'] > 25]
    dfx = dfx.reset_index()
    dfx =  dfx.drop(['index'] , axis = 1)
    print("summarizing - ")

    dfx['Summarized'] = " "

    for i in range(len(dfx['Sentence'])):
        try:
            dfx['Summarized'][i] = inference( 150, 0, 1, dfx['Sentence'][i], command, mode="summary")
        except Exception as e:
            print(i)
            print(e)

    for n in range(len(dfx['Sentence_tag2'])):
    #     if "COMMON" in dfx['Sentence_tag2'][n]:
    #         dfx['Sentence_tag2'][n] = "COMMON"
        dfx['Sentence_tag2'][n] = dfx['Sentence_tag2'][n].strip()

    dfx = dfx.groupby(['Sentence_tag2' ]).agg({'Summarized':'. '.join }).reset_index()        
    dfx['Topics'] = " "
    print("Topics Generation -")

    for i in range(len(dfx['Summarized'])):
        try:
            dfx['Topics'][i] = title( dfx['Summarized'][i])
            sleep(2)
        except Exception as e:
            print(i)
            print(e)
    dfc = dfx
    dfx = dfx[~dfx['Sentence_tag2'].isin(['PERCENT', 'DATE', 'WORK_OF_ART'])]
    # dfx['Topic_Length'] =  dfx['Topics'].apply(lambda x: len(x.split(" "))) 
    # dfxx = dfx[dfx['Topic_Length'] < 15]
    dfx['Final Topics'] = " "
    dfx = dfx.reset_index()
    dfx =  dfx.drop(['index'] , axis = 1)
    for i in range(len(dfx['Topics'])):
        try:
            dfx['Final Topics'][i] = dfx['Topics'][i].split("\n\n")[1].split(":")[0]
        except Exception as  e:
            print(e, "    ", i)
            dfx['Final Topics'][i] =  dfx['Topics'][i]

#     dfx['Final Topics'] = dfx['Topics'].apply(lambda x: x.split("\n\n")[1].split(":")[0])
    
    dfx = dfx[['Summarized', 'Final Topics']]
    dfx.to_csv("Summarised.csv")
    print('completed')
    
def getText(filename):
    with open(filename) as f:
        lines = f.readlines()
    return lines[0]

def Summarization(path):
    Video_to_Audio(path)
    Create_Transcript()
    make_output()
    print("output is present in ", os.getcwd())
    


# In[45]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:





# In[ ]:




