#!/usr/bin/env python
# coding: utf-8

# In[ ]:


from setuptools import setup, find_packages
import codecs
import os



VERSION = '0.0.1'
DESCRIPTION = 'Video Summarization'
LONG_DESCRIPTION = 'Summarize a given set of videos'

# Setting up
setup(
    name="VidSummarization",
    version=VERSION,
    author="Subeesh Kannan",
    author_email="subeesh.kannan@chryselys.com",
    description=DESCRIPTION,
    long_description_content_type="text/markdown",
    long_description=LONG_DESCRIPTION,
    packages=find_packages(),
    install_requires=['moviepy', 'openai', 'pandas', 'nltk'],
    keywords=['moviepy', 'openai', 'pandas', 'nltk'],
    classifiers=[
        "Development Status :: 1 - Planning",
        "Intended Audience :: Developers",
        "Programming Language :: Python :: 3",
        "Operating System :: Unix",
        "Operating System :: MacOS :: MacOS X",
        "Operating System :: Microsoft :: Windows",
    ]
)

